<template>
    <v-card>
        <h1 class="text-center">User Administration</h1>
        <user-table :users="users"
        @delete-user="deleteUser"
        @save-users="saveUsers"></user-table>
    <v-divider/>
        <create-user @create-user="createUser"></create-user>
    <v-snackbar v-model="errorInfo.showError" color="error">
        {{ errorInfo.errorMessage }}
    </v-snackbar>
    <v-snackbar v-model="successInfo.showMessage" color="success">
        {{ successInfo.succesMessage }}
    </v-snackbar>
    </v-card>
</template>

<script>
import UserTable from "@/components/UserTable"
import UserService from "@/services/UserService"
import CreateUser from "@/components/CreateUser"
export default {
    name:"UserAdministration",
    components:{
        UserTable,
        CreateUser
        },
        data:()=>({
            users: Array,
            errorInfo: {
                showError: false,
                errorMessage: "",
            },
            successInfo: {
                showMessage: false,
                succesMessage: "",
            }
        }),
        created(){
            this.getUsers();
        },
        methods:{
            createUser(user){
                UserService.add(user).then(this.handleSuccess("User successfully created!")).then(this.getUsers)
                .catch((error) => {
                this.handleError("Creating user failed",error);
            });
            },
            getUsers(){
                UserService.get().then((users)=>{
                    this.users = users
                })
                .catch((error) => {
                this.handleError("Loading users failed",error);
            });
            },
            deleteUser(user){
                UserService.delete(user).then(this.handleSuccess("User successfully deleted!")).then(this.getUsers)
                .catch((error) => {
                this.handleError("Deleting user failed",error);
            });
            },
            saveUsers(users){
                users.forEach(user => {
                    UserService.put(user)
                }).then(this.handleSuccess("Users successfully saved!")).then(this.getUsers)
                .catch((error) => {
                this.handleError("Saving users failed",error);
            });
            },
            handleError(userMessage, error){
                this.errorInfo.errorMessage = userMessage;
                this.errorInfo.showError = true;
                console.log(error);
            },
            handleSuccess(userMessage){
                this.successInfo.succesMessage = userMessage;
                this.successInfo.showMessage = true;
            }
        }
}
</script>